main :: IO()
main = print "Loaded"

-- Answers to SECTION 3

-- ANSWERS TO STARTER
-- Example 1
-- An example of a function assigned as a variable (very)
enthusiastically f x = f (f (f x) )
very = enthusiastically

-- Example 2
-- An example of function assigned as argument (here, "square" is an argument to "map")
square x = x * x
newList = map square [1..100]

-- Example 3
-- An example of function in an expression (here, the function "even" is used the Boolean expression)
isAllowed n
  | even n || n > 35 = True
  | otherwise = False

-- Example 4
-- An example of function returned in a function call
-- E.g. foo 10 will return a function that puts its argument to the power of 10. 
foo n = \x -> n**x
twoToPowerOf = foo 2
threeToPowerOf = foo 3

-- What is the result of twoToPowerOf 10? 2 ^ 10 = 1024
-- What is the result of threeToPowerOf 3? 3 ^ 3 = 27

-- Example answers to TASK 1

-- Function "reverse" is argument to map
map reverse [ "cat" , "horse" , "rabbit" ]

-- Function "even" is argument to "filter"
filter even [1..10]

-- Function "+" is argument to "foldl"
foldl (+) 100 [2, 4 , 6, 8]


-- TASK 2

-- What does "deriv" do?
deriv f = \x -> (f (x + dx) - f x) / dx
  where dx = 0.001

-- "deriv" takes as argument a function f and returns another function takes an argument (x) and calculates the approximate value of the derivative (gradient) of original function f at x. 

derivCube = deriv cube
derivPoly = deriv poly



-- Answers to SECTION 4

--Code for the STARTER:

list1 = map (+3) [1..20]

list2 = map (&& True) [True, False, True, False]

list3 = map (<=4) [-6, -3..20]

list4 = map (min 5) [1..10]


--Code for Task 1

:t (+) 
:t (+3) 
 
:t (&&) 
:t (&& True) 
 
:t (<=) 
:t (<=4) 


-- EXAMPLE ANSWERS TO TASK 2

-- (ii)
greaterThan100 = (>100)

-- (iii)
plus100 = (+ 100)

-- (iv)
rectify = max 0

-- (v) 
square x = x * x
squareList = map square

-- (vi)
sumList = foldl (+) 0

-- (vii)
filterPos = filter (>0)